﻿Public Class Form1

    Private Sub NewToolStripMenuItem_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles NewToolStripMenuItem.Click

        'Czyszczenie zawartości pól tekstowych.
        TextBox1.Text = String.Empty
        TextBox2.Text = String.Empty

        'Ustawianie pierwszego pola jako aktywnego.
        TextBox1.Focus()
    End Sub

    Private Sub NewToolStripButton_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles NewToolStripButton.Click
        'Wywołanie metody newToolStripMenuItem_Click.
        NewToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        'Zamykanie formularza.
        Me.Close()
    End Sub

    Private Sub UndoToolStripMenuItem_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles UndoToolStripMenuItem.Click
        'Cofnięcie ostatniej operacji.
        If TypeOf Me.ActiveControl Is TextBox Then
            CType(Me.ActiveControl, TextBox).Undo()
        End If
    End Sub

    Private Sub CutToolStripMenuItem_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles CutToolStripMenuItem.Click
        'Skopiowanie tekstu do schowka i wyczyszczenie pola.
        If TypeOf Me.ActiveControl Is TextBox Then
            CType(Me.ActiveControl, TextBox).Cut()
        End If
    End Sub

    Private Sub CutToolStripButton_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles CutToolStripButton.Click
        'Wywołanie procedury CutToolStripMenuItem_Click.
        CutToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles CopyToolStripMenuItem.Click
        'Kopiowanie tekstu do schowka.
        If TypeOf Me.ActiveControl Is TextBox Then
            CType(Me.ActiveControl, TextBox).Copy()
        End If
    End Sub

    Private Sub CopyToolStripButton_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles CopyToolStripButton.Click
        'Wywołanie procedury CopyToolStripMenuItem_Click.
        CopyToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub PasteToolStripMenuItem_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles PasteToolStripMenuItem.Click
        'Kopiowanie danych ze schowka do pola tekstowego.
        If TypeOf Me.ActiveControl Is TextBox Then
            CType(Me.ActiveControl, TextBox).Paste()
        End If
    End Sub

    Private Sub PasteToolStripButton_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles PasteToolStripButton.Click
        'Wywołanie procedury PasteToolStripMenuItem_Click.
        PasteToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub SelectAllToolStripMenuItem_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles SelectAllToolStripMenuItem.Click
        'Zaznaczanie całego tekstu.
        If TypeOf Me.ActiveControl Is TextBox Then
            CType(Me.ActiveControl, TextBox).SelectAll()
        End If
    End Sub

    Private Sub MainToolStripMenuItem_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles MainToolStripMenuItem.Click
        'Przełącza widoczność standardowego paska narzędzi
        'na podstawie wartości właściwości Checked.
        If MainToolStripMenuItem.Checked Then
            tspMain.Visible = True
        Else
            tspMain.Visible = False
        End If
    End Sub

    Private Sub FormattingToolStripMenuItem_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles FormattingToolStripMenuItem.Click
        'Przełącza widoczność paska narzędzi Formatowanie
        'na podstawie wartości właściwości Checked.
        If FormattingToolStripMenuItem.Checked Then
            tspFormatting.Visible = True
        Else
            tspFormatting.Visible = False
        End If
    End Sub

    Private Sub ContextUndoToolStripMenuItem_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles ContextUndoToolStripMenuItem.Click
        'Wywołanie procedury UndoToolStripMenuItem_Click.
        UndoToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ContextCutToolStripMenuItem_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles ContextCutToolStripMenuItem.Click
        'Wywołanie procedury CutToolStripMenuItem_Click.
        CutToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ContextCopyToolStripMenuItem_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles ContextCopyToolStripMenuItem.Click
        'Wywołanie procedury CopyToolStripMenuItem_Click.
        CopyToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ContextPasteToolStripMenuItem_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles ContextPasteToolStripMenuItem.Click
        'Wywołanie procedury PasteToolStripMenuItem_Click.
        PasteToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ContextSelectAllToolStripMenuItem_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) _
        Handles ContextSelectAllToolStripMenuItem.Click
        'Wywołanie procedury SelectAllToolStripMenuItem_Click.
        SelectAllToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ToggleMenus()
        'Deklaracja obiektu typu TextBox i i przypisanie do niego aktywnej kontrolki.
        Dim objTextBox As TextBox = CType(Me.ActiveControl, TextBox)

        'Deklarowanie i ustawianie zmiennej logicznej.
        Dim blnEnabled As Boolean = CType(objTextBox.SelectionLength, Boolean)

        'Przełączanie opcji Cofnij.
        UndoToolStripMenuItem.Enabled = objTextBox.CanUndo
        ContextUndoToolStripMenuItem.Enabled = objTextBox.CanUndo

        'Przełączanie opcji i przycisku Wytnij.
        CutToolStripButton.Enabled = blnEnabled
        CutToolStripMenuItem.Enabled = blnEnabled
        ContextCutToolStripMenuItem.Enabled = blnEnabled

        'Przełączanie opcji i przycisku Kopiuj.
        CopyToolStripButton.Enabled = blnEnabled
        CopyToolStripMenuItem.Enabled = blnEnabled
        ContextCopyToolStripMenuItem.Enabled = blnEnabled

        'Ponowne ustawianie zmiennej blnEnabled.
        blnEnabled = My.Computer.Clipboard.ContainsText

        'Przełączanie opcji i przycisku Wklej.
        PasteToolStripButton.Enabled = blnEnabled
        PasteToolStripMenuItem.Enabled = blnEnabled
        ContextPasteToolStripMenuItem.Enabled = blnEnabled

        'Ponowne ustawianie zmiennej blnEnabled.
        If objTextBox.SelectionLength < objTextBox.TextLength Then
            blnEnabled = True
        Else
            blnEnabled = False
        End If

        'Przełączanie opcji Zaznacz wszystko.
        SelectAllToolStripMenuItem.Enabled = blnEnabled
        ContextSelectAllToolStripMenuItem.Enabled = blnEnabled
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, _
     ByVal e As System.EventArgs) Handles Timer1.Tick
        'Ustawianie przycisków i opcji.
        ToggleMenus()
    End Sub

End Class
